
IID_IPicture GUID 7bf80980-bf32-101a-8bbb-00aa00300cab
interface IPicture,\
	  QueryInterface,\
	  AddRef,\
	  Release,\
	  get_Handle,\
	  get_hPal,\
	  get_Type,\
	  get_Width,\
	  get_Height,\
	  Render,\
	  set_hPal,\
	  get_CurDC,\
	  SelectPicture,\
	  get_KeepOriginalFormat,\
	  put_KeepOriginalFormat,\
	  PictureChanged,\
	  SaveAsFile,\
	  get_Attributes

proc IPicture_Load uses ebx esi edi,hModule,ResId,ResType

     locals
       Stream IStream
       Pict IPicture
     endl

     xor eax,eax
     mov [Pict],eax

     invoke FindResource,[hModule],[ResId],[ResType]
     .if eax
	 mov edi,eax
	 invoke SizeofResource,[hModule],edi
	 .if eax
	     mov esi,eax
	     invoke CoTaskMemAlloc,esi
	     .if eax
		 mov ebx,eax
		 invoke LoadResource,[hModule],edi
		 .if eax
		     invoke LockResource,eax
		     .if eax
			 invoke RtlMoveMemory,ebx,eax,esi
			 invoke CreateStreamOnHGlobal,ebx,TRUE,addr Stream
			 .if eax = S_OK
			     invoke OleLoadPicture,[Stream],0,TRUE,IID_IPicture,addr Pict
			     cominvk Stream,Release
			 .endif
		     .endif
		 .endif
	     .endif
	 .endif
     .endif

     mov eax,[Pict]

     ret
endp

proc IPicture_Free,Picture
     assume Picture,IPicture
     .if [Picture]
	 cominvk .Picture,Release
     .endif
     ret
endp

proc IPicture_GetSize uses esi edi,Picture,pWidth,pHeight

     LOGPIXELSX = 88
     LOGPIXELSY = 90
     HIMETRIC_INCH = 2540

     assume Picture,IPicture
     xor eax,eax

     .if [Picture]
	 invoke GetDC,NULL
	 .if eax
	     mov edi,eax

	     cominvk .Picture,get_Width,[pWidth]
	     cominvk .Picture,get_Height,[pHeight]

	     invoke GetDeviceCaps,edi,LOGPIXELSX
	     mov esi,[pWidth]
	     invoke MulDiv,DWORD[esi],eax,HIMETRIC_INCH
	     mov [esi],eax

	     invoke GetDeviceCaps,edi,LOGPIXELSY
	     mov esi,[pHeight]
	     invoke MulDiv,DWORD[esi],eax,HIMETRIC_INCH
	     mov [esi],eax

	     invoke ReleaseDC,NULL,edi
	 .endif
     .endif

     ret
endp

proc IPicture_GetBitmapHandle,Picture

     local hPictBmp:DWORD

     assume Picture,IPicture

     .if [Picture]
	 cominvk .Picture,get_Handle,addr hPictBmp
	 mov eax,[hPictBmp]
     .endif

     ret
endp
